Package org.python.modules._io

# Class PyRawIOBase

java.lang.Object
org.python.core.PyObject
org.python.modules._io.PyIOBase
org.python.modules._io.PyRawIOBase

All Implemented Interfaces:
  `Serializable`, `FinalizableBuiltin`, `Traverseproc`

Direct Known Subclasses:
  `PyFileIO`, `PyRawIOBaseDerived`

public class PyRawIOBase extends PyIOBase
An implementation of Python `_io._RawIOBase` mirroring the arrangement of methods in the CPython version.

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class org.python.core.PyObject

`PyObject.ConversionException`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`read_doc`
`static final String`
`readall_doc`
`static final String`
`readinto_doc`
`static final PyType`
`TYPE`
`static final String`
`write_doc`

### Fields inherited from class org.python.modules._io.PyIOBase

`close_doc, closed_doc, fileno_doc, flush_doc, isatty_doc, readable_doc, readline_doc, readlines_doc, seek_doc, seekable_doc, tell_doc, truncate_doc, writable_doc, writelines_doc`

### Fields inherited from class org.python.core.PyObject

`gcMonitorGlobal`

## Constructor Summary

Constructors
Constructor
Description
`PyRawIOBase()`
`PyRawIOBase(PyType subtype)`

## Method Summary

Modifier and Type
Method
Description
`PyObject`
`read(int n)`
The read() method is implemented by calling readinto(); derived classes that want to support read() only need to implement readinto() as a primitive operation.
`PyObject`
`readall()`
Read until end of file, using multiple `read()` operations on the underlying stream.
`PyObject`
`readinto(PyObject b)`
Read up to `len(b)` bytes into `bytearray b` and return the number of bytes read.
`PyObject`
`write(PyObject b)`
Write the given bytes or bytearray object to the underlying raw stream and return the number of bytes written.

### Methods inherited from class org.python.modules._io.PyIOBase

`__del_builtin__, __enter__, __exit__, __iter__, __iternext__, _checkClosed, _checkClosed, _checkReadable, _checkReadable, _checkSeekable, _checkSeekable, _checkWritable, _checkWritable, close, closed, closed_readonly, fastGetDict, fileno, flush, isatty, next, readable, readline, readline, readlines, refersDirectlyTo, seek, seek, seekable, tell, traverse, truncate, truncate, writable, writelines`

### Methods inherited from class org.python.core.PyObject

`__abs__, __add__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __cmp__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delattr__, __delete__, __delitem__, __delitem__, __delslice__, __delslice__, __dir__, __div__, __divmod__, __ensure_finalizer__, __eq__, __findattr__, __findattr__, __findattr_ex__, __finditem__, __finditem__, __finditem__, __float__, __floordiv__, __format__, __ge__, __get__, __getattr__, __getattr__, __getitem__, __getitem__, __getnewargs__, __getslice__, __getslice__, __gt__, __hash__, __hex__, __iadd__, __iand__, __idiv__, __idivmod__, __ifloordiv__, __ilshift__, __imod__, __imul__, __index__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __itruediv__, __ixor__, __le__, __len__, __long__, __lshift__, __lt__, __mod__, __mul__, __ne__, __neg__, __nonzero__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __radd__, __rand__, __rdiv__, __rdivmod__, __reduce__, __reduce_ex__, __reduce_ex__, __repr__, __rfloordiv__, __rlshift__, __rmod__, __rmul__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rtruediv__, __rxor__, __set__, __setattr__, __setattr__, __setitem__, __setitem__, __setitem__, __setslice__, __setslice__, __str__, __sub__, __tojava__, __truediv__, __trunc__, __unicode__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _doget, _doget, _doset, _eq, _floordiv, _ge, _gt, _iadd, _iand, _idiv, _idivmod, _ifloordiv, _ilshift, _imod, _imul, _in, _ior, _ipow, _irshift, _is, _isnot, _isub, _itruediv, _ixor, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _truediv, _xor, asDouble, asIndex, asIndex, asInt, asInt, asIterable, asLong, asLong, asName, asName, asString, asString, asStringOrNull, asStringOrNull, bit_length, conjugate, delDict, delType, dispatch__init__, equals, fastGetClass, getDict, getType, hashCode, implementsDescrDelete, implementsDescrGet, implementsDescrSet, invoke, invoke, invoke, invoke, invoke, invoke, isCallable, isDataDescr, isIndex, isInteger, isMappingType, isNumberType, isSequenceType, noAttributeError, object___subclasshook__, readonlyAttributeError, setDict, setType, toString`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### TYPE

public static final PyType TYPE

### read_doc

public static final String read_doc

See Also:
  - Constant Field Values

### readall_doc

public static final String readall_doc

See Also:
  - Constant Field Values

### readinto_doc

public static final String readinto_doc

See Also:
  - Constant Field Values

### write_doc

public static final String write_doc

See Also:
  - Constant Field Values

## Constructor Details

### PyRawIOBase

public PyRawIOBase()

### PyRawIOBase

public PyRawIOBase(PyType subtype)

## Method Details

### read

public PyObject read(int n)
The read() method is implemented by calling readinto(); derived classes that want to support read() only need to implement readinto() as a primitive operation. In general, readinto() can be more efficient than read().

Parameters:
  `n` - number of bytes to read (if possible)
Returns:
  a PyString holding the bytes read or `Py.None` (when a non-blocking source is not ready with further data)

### readall

public PyObject readall()
Read until end of file, using multiple `read()` operations on the underlying stream. If the first `read()` returns `None` (only possible in the case of a non-blocking stream), this method returns `None`.

Returns:
  a PyString holding the bytes read or `Py.None` (when a non-blocking source is not ready with further data)

### readinto

public PyObject readinto(PyObject b)
Read up to `len(b)` bytes into `bytearray b` and return the number of bytes read. If the object is in non-blocking mode and no bytes are available, `None` is returned.";

Parameters:
  `b` - byte array to try to fill
Returns:
  number of bytes actually read or `Py.None` (when a non-blocking source is not ready with further data)

### write

public PyObject write(PyObject b)
Write the given bytes or bytearray object to the underlying raw stream and return the number of bytes written.

Parameters:
  `b` - buffer of bytes to be written
Returns:
  the number of bytes written